
// AvrHexEepromDoc.cpp: Implementierung der Klasse CAvrHexEepromDoc
//

#include "stdafx.h"
#include "AvrHexEeprom.h"

#include "AvrHexEepromDoc.h"
#include "SrvrItem.h"
#include "VarZeile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAvrHexEepromDoc
/*static*/ 
std::vector<CZeilenFormat> CAvrHexEepromDoc::m_DefaultFormat((size_t)MAX_DATA_BYTES);

IMPLEMENT_DYNCREATE(CAvrHexEepromDoc, CDocument)

BEGIN_MESSAGE_MAP(CAvrHexEepromDoc, CDocument)
   ON_COMMAND(ID_DATEI_SAVEFORMATASDEFAULT, &CAvrHexEepromDoc::OnDateiSaveformatasdefault)
   ON_COMMAND(ID_DATEI_LOADDEFAULTFORMAT, &CAvrHexEepromDoc::OnDateiLoaddefaultformat)
   ON_COMMAND(ID_DATEI_SAVEFORMAT, &CAvrHexEepromDoc::OnDateiSaveformat)
   ON_COMMAND(ID_DATEI_LOADFORMAT, &CAvrHexEepromDoc::OnDateiLoadformat)
END_MESSAGE_MAP()


// CAvrHexEepromDoc-Erstellung/Zerstrung

CAvrHexEepromDoc::CAvrHexEepromDoc()
   :m_nBytes       (0x100)
   ,m_DefaultByte  (0xFF)
   ,m_nBytesColBit ( 4 )
   ,m_nStartByteAdd(0)
{
   m_Format = m_DefaultFormat;
   InitData();
   BytesToString();
   m_nBytes = 0x100;
}
void CAvrHexEepromDoc::InitData()
{
   m_nBytes = 0;
   memset( m_data, m_DefaultByte, sizeof m_data );
   memset( m_used, 0, sizeof m_used );
}

CAvrHexEepromDoc::~CAvrHexEepromDoc()
{
}

BOOL CAvrHexEepromDoc::OnNewDocument()
{
	if (!__super::OnNewDocument())
		return FALSE;

	// TODO: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)
   LoadDefaultFormat();
   m_Format = m_DefaultFormat;
	return TRUE;
}


// CAvrHexEepromDoc Serverimplementierung

// COleServerItem* CAvrHexEepromDoc::OnGetEmbeddedItem()
// {
// 	// OnGetEmbeddedItem wird automatisch aufgerufen, um COleServerItem zu erhalten,
// 	//  das mit dem Dokument verknpft ist. Die Funktion wird nur bei Bedarf aufgerufen.
// 
// 	CAvrHexEepromSrvrItem* pItem = new CAvrHexEepromSrvrItem(this);
// 	ASSERT_VALID(pItem);
// 	return pItem;
// }




// CAvrHexEepromDoc-Serialisierung

void CAvrHexEepromDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
      BytesToString();
      ar.Write( m_strIntelHex.GetString(), m_strIntelHex.GetLength()*sizeof(TCHAR));


	}
	else
	{
      CFile* pFile = ar.GetFile();
      ASSERT(pFile->GetPosition() == 0);
      ULONGLONG nFileSize = pFile->GetLength();
//       if (nFileSize/sizeof(TCHAR) > GetEditCtrl().GetLimitText())
//       {
//          // Larger than edit control limit. Call SetLimitText() to set your own max size.
//          // Refer to documentation for EM_LIMITTEXT for max sizes for your target OS.
//          AfxMessageBox(AFX_IDP_FILE_TOO_LARGE);
//          AfxThrowUserException();
//       }
      // ReadFromArchive takes the number of characters as argument
      char* sz = m_strIntelHex.GetBufferSetLength( nFileSize + 1);
      ar.Read(sz, nFileSize );
      sz[nFileSize] = '\0';
      m_strIntelHex.ReleaseBuffer(nFileSize + 1);
      StringToBytes();
	}
}


// CAvrHexEepromDoc-Diagnose

#ifdef _DEBUG
void CAvrHexEepromDoc::AssertValid() const
{
	__super::AssertValid();
}

void CAvrHexEepromDoc::Dump(CDumpContext& dc) const
{
	__super::Dump(dc);
}


#endif //_DEBUG


// CAvrHexEepromDoc-Befehle


void CAvrHexEepromDoc::StringToBytes()
{
   InitData();
   int nStartByteAddTmp = INT_MAX;
   int nMaxNutzDatenCnt = 0;
   char* pD = (char*)m_data;

   const char* p  = m_strIntelHex.GetString();
   for( int z=0 ; *p ; z++ )
   {
      while(*p && *p != ':' )
         p++;
      if(*p && *p == ':')
         p++;
      const char* tmp = p;
      int   nLen = 0;
      while(*tmp && isxdigit(*tmp) )
      {
         tmp++;
         nLen++;
      }
      if( nLen < 10 )
      {
         p=tmp;
         continue;
      }
      long nNutzDatenCnt = AsciiHexToByte(p);
      p++;p++;
      long nAddress      = (AsciiHexToByte(p)<<8) + AsciiHexToByte(p+2);
      p++;p++;
      p++;p++;
      nStartByteAddTmp   = min(nAddress,nStartByteAddTmp);
      long nCmd          = AsciiHexToByte(p);
      p++;p++;

      if( nCmd )
      {
         p=tmp;
         continue;
      }

      BYTE pruef = 0;
      for( int n=0 ; *p && n<nNutzDatenCnt ; n++ )
      {
         BYTE val = AsciiHexToByte( p + 2*n );
         if((nAddress + n) < sizeof m_data)
         {
            BYTE val = AsciiHexToByte( p + 2*n );
            m_data[ nAddress + n ] = val;
            m_used[ nAddress + n ] = TRUE;
            m_nBytes = max(  nAddress + n+1, m_nBytes );
            pruef += val;
         }
      }
      nMaxNutzDatenCnt = max(nMaxNutzDatenCnt,nNutzDatenCnt);
      BYTE pruefB = AsciiHexToByte( p + 2*nNutzDatenCnt );
      pruef += pruefB;
      BOOL bOk = !pruef;
      if( !bOk )
         MessageBeep(-1);
      p=tmp;
   }
   if(nMaxNutzDatenCnt)
   {
      for( int i=0 ; i<8 ; i++ )
         if( nMaxNutzDatenCnt>>i )
            m_nBytesColBit = i;
   }
   if(nStartByteAddTmp != INT_MAX)
      m_nStartByteAdd = nStartByteAddTmp;
}

void CAvrHexEepromDoc::BytesToString()
{
   CString str;
   CString strAll;
   DWORD   dwBytesLeft = m_nBytes;
   int     nBytesCol   = (1<<m_nBytesColBit);
   int     i           = m_nStartByteAdd;
   BYTE    btChk       = 0;
   while( dwBytesLeft && i<sizeof m_data)
   {  
      btChk       = 0;
      long nDataCntCol = min(dwBytesLeft,nBytesCol);
      str.Format(_T(":%02X%04X00"),nDataCntCol ,i);
      strAll += str;
      btChk += nDataCntCol;
      btChk += i>>8     ;
      btChk += i & 0xFF ;
      btChk += 0        ;
      for( BYTE c=0 ; c<nDataCntCol && i<sizeof m_data ; i++ ,c++,  --dwBytesLeft)
      {
         str.Format(_T("%02X"), m_data[i] );
         strAll += str;
         btChk += m_data[i];
      }
      btChk = (btChk^0xFF); //zweierkompl.
      btChk += 1;
      str.Format(_T("%02X\r\n"), btChk );
      strAll += str;
   }
   strAll += _T(":00000001FF");
   m_strIntelHex = strAll;

}

void CAvrHexEepromDoc::OnDateiSaveformatasdefault()
{
   m_DefaultFormat = m_Format;
   SaveDefaultFormat();
}

void CAvrHexEepromDoc::OnDateiLoaddefaultformat()
{
   LoadDefaultFormat();
   m_Format = m_DefaultFormat;

   UpdateAllViews(NULL, HintNewFormat );
}

void CAvrHexEepromDoc::OnDateiSaveformat()
{
   CString str = GetTitle();
   str += _T(".HexFormat");
   CFileDialog dlg(FALSE,_T("HexFormat"),str, OFN_ENABLESIZING | OFN_OVERWRITEPROMPT );
   if( IDOK == dlg.DoModal() )
   {
      CFile file;
      if( file.Open(dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite) )
      {
         file.Write( &m_Format[0],m_Format.size() * sizeof m_Format[0] );
      }
   }
}

void CAvrHexEepromDoc::OnDateiLoadformat()
{
   CString str = GetTitle();
   str += _T(".HexFormat");
   CFileDialog dlg(TRUE,_T("HexFormat"),str, OFN_ENABLESIZING | OFN_OVERWRITEPROMPT );
   if( IDOK == dlg.DoModal() )
   {
      CFile file;
      if( file.Open(dlg.GetPathName(), CFile::modeRead) )
      {
         CFileStatus status;
         if( file.GetStatus(status) )
            if( status.m_size == m_Format.size() * sizeof m_Format[0] )
               file.Read( &m_Format[0], status.m_size );
      }
   }
   UpdateAllViews(NULL, HintNewFormat );
}
