
// AvrHexEepromDoc.h: Schnittstelle der Klasse CAvrHexEepromDoc
//


#pragma once

#include <vector>
#include "ZeilenFormat.h"


static inline CString GetModulDir()
{
   TCHAR drive[_MAX_DRIVE];
   TCHAR dir[_MAX_DIR];
   TCHAR fname[_MAX_FNAME];
   TCHAR ext[_MAX_EXT];

   //PathCanonicalize(..) doesn't work with for all Plattforms !
   CString strModule;
   GetModuleFileName(NULL,strModule.GetBuffer(_MAX_FNAME),_MAX_FNAME);
   strModule.ReleaseBuffer();
   _tsplitpath( strModule, drive, dir, fname, ext );
   strModule = drive;
   strModule+= dir;
   return strModule;
}


#define MAX_DATA_BYTES 0x1000

//class CAvrHexEepromSrvrItem;

class CAvrHexEepromDoc : public CDocument
{
protected: // Nur aus Serialisierung erstellen
	CAvrHexEepromDoc();
	DECLARE_DYNCREATE(CAvrHexEepromDoc)

// Attribute
public:
// 	CAvrHexEepromSrvrItem* GetEmbeddedItem()
// 		{ return reinterpret_cast<CAvrHexEepromSrvrItem*>(COleServerDoc::GetEmbeddedItem()); }

// Vorgnge
public:

   static const int HintNewFormat = 1;


   void StringToBytes()    ;
   void BytesToString()    ;

   static CString  GetDefaultFormatFileName()
   {
      CString strDef = GetModulDir();
      strDef += _T("DefaultHexFileFormat.HexFormat");
      return strDef;
   }
   static void LoadDefaultFormat()
   {
      CFile file;
      if( file.Open(GetDefaultFormatFileName(), CFile::modeRead) )
      {
         CFileStatus status;
         if( file.GetStatus(status) )
            if( status.m_size == m_DefaultFormat.size() * sizeof m_DefaultFormat[0] )
               file.Read( &m_DefaultFormat[0], status.m_size );
      }
   }
   static void SaveDefaultFormat()
   {
      CFile file;
      if( file.Open(GetDefaultFormatFileName(), CFile::modeCreate | CFile::modeWrite) )
      {
         file.Write( &m_DefaultFormat[0],m_DefaultFormat.size() * sizeof m_DefaultFormat[0] );
      }
   }

   BYTE          m_data  [MAX_DATA_BYTES ];
   BYTE          m_used  [MAX_DATA_BYTES ];
   std::vector<CZeilenFormat>        m_Format;
   static std::vector<CZeilenFormat> m_DefaultFormat;

   BYTE     m_DefaultByte  ;
   int      m_nBytes       ; //Last Byte# +1
   int      m_nStartByteAdd; //First Address
   int      m_nBytesColBit ; // 0: 1Byte/col 1:2Byte/Col 2:4Byte/Col 3:8Byte/Col 4:16Byte/Col...
   CStringA m_strIntelHex  ; //Kein TCHAR

// berschreibungen
protected:
//	virtual COleServerItem* OnGetEmbeddedItem();
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementierung
public:
	virtual ~CAvrHexEepromDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Funktionen fr die Meldungstabellen
protected:
	DECLARE_MESSAGE_MAP()
   void InitData();
public:
   afx_msg void OnDateiSaveformatasdefault();
   afx_msg void OnDateiLoaddefaultformat();
   afx_msg void OnDateiSaveformat();
   afx_msg void OnDateiLoadformat();
};


