
// AvrHexEepromView.cpp: Implementierung der Klasse CAvrHexEepromView
//

#include "stdafx.h"
#include "AvrHexEeprom.h"

#include "AvrHexEepromDoc.h"
#include "AvrHexEepromView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



UINT ID_START_TOPIC   = 1000;
UINT ID_START_CONTROL = 2000;
UINT CONTROL_DELTA    = CAvrHexEepromView::ZEILEN;

// CAvrHexEepromView

IMPLEMENT_DYNCREATE(CAvrHexEepromView, CFormView)

BEGIN_MESSAGE_MAP(CAvrHexEepromView, CFormView)
//	ON_COMMAND(ID_CANCEL_EDIT_SRVR, &CAvrHexEepromView::OnCancelEditSrvr)
   ON_CONTROL_RANGE(BN_CLICKED, ID_START_CONTROL, ID_START_CONTROL + SPALTEN*CAvrHexEepromView::ZEILEN, &CAvrHexEepromView::OnBnClickedRange )
   ON_CONTROL_RANGE(EN_CHANGE , ID_START_CONTROL, ID_START_CONTROL + SPALTEN*CAvrHexEepromView::ZEILEN, &CAvrHexEepromView::OnEnChangeRange )
   ON_CONTROL_RANGE(EN_CHANGE , IDC_EDIT_SIZE_DEZ , IDC_EDIT_SIZE_HEX , &CAvrHexEepromView::OnEnChangeSize )
   ON_CONTROL_RANGE(EN_CHANGE , IDC_EDIT_SIZE_DEZ2, IDC_EDIT_SIZE_HEX2, &CAvrHexEepromView::OnEnChangeStartAdd )
   ON_CONTROL_RANGE(BN_CLICKED, IDC_RADIO_BYTES_COL_0, IDC_RADIO_BYTES_COL_6, &CAvrHexEepromView::OnUpdateDataTrueFalse )
   ON_WM_SIZE()
   ON_WM_VSCROLL()
END_MESSAGE_MAP()

// CAvrHexEepromView-Erstellung/Zerstrung

CAvrHexEepromView::CAvrHexEepromView()
	: CFormView(CAvrHexEepromView::IDD)
   , m_dwStartZeile   (0)
   , m_bLockRekursive (FALSE)
{
	// TODO: Hier Code zur Konstruktion einfgen

}

CAvrHexEepromView::~CAvrHexEepromView()
{
   for( int i=0 ; i<m_arTopics.size() ; i++ )
   {
      delete m_arTopics[i];
   }
}

void CAvrHexEepromView::DoDataExchange(CDataExchange* pDX)
{
   CAvrHexEepromDoc* pDoc = GetDocument();
	CFormView::DoDataExchange(pDX);
   DDX_Radio(pDX, IDC_RADIO_BYTES_COL_0, pDoc->m_nBytesColBit );
}

BOOL CAvrHexEepromView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CFormView::PreCreateWindow(cs);
}

void CAvrHexEepromView::OnInitialUpdate()
{
   CAvrHexEepromDoc* pDoc = GetDocument();
	CFormView::OnInitialUpdate();
	ResizeParentToFit();
   m_font.CreatePointFont( 90, _T("Courier"));
   CWnd* pEdit = GetDlgItem( IDC_EDIT_BYTES_RAW);
   pEdit->SetFont( &m_font );
   CRect rect;
   pEdit->GetWindowRect(rect);
   ScreenToClient(rect);
   CPoint ptContr(rect.left+20, rect.bottom + 20);

   CVarZeile::CreateTopics(this, ptContr, ID_START_TOPIC, m_arTopics);
   ptContr.y += 18;

   for( int i=0 ; i< ZEILEN ; i++ )
   {
      m_arZeilen[i].CreateControls(this, ptContr , ID_START_CONTROL + i , CONTROL_DELTA );
      m_arZeilen[i].SetDataPointer( &pDoc->m_data[i] );
      m_arZeilen[i].SetDataFormat ( &pDoc->m_Format[i] );
      m_arZeilen[i].SetDataAddress( i );
      m_arZeilen[i].UpdateControls();
      ptContr.y += 18;
   }
   EnableDisableControls();

   CSize size( rect.right , ptContr.y +10 );
   SetScrollSizes(MM_TEXT, size);
   ResizeParentToFit();

}

void CAvrHexEepromView::EnableDisableControls()
{
   CAvrHexEepromDoc* pDoc = GetDocument();
   for( int i=0 ; i< ZEILEN &&  i + m_dwStartZeile < sizeof pDoc->m_data + ZEILEN ; i++ )
   {
      m_arZeilen[i].EnableControls();
   }
   for( int i=-3 ; i<ZEILEN ; i++ )
   {
      int iSrc = m_dwStartZeile + i;
      if( iSrc >= sizeof pDoc->m_data )
         continue;
      for( int next=1 ; next<4 ; next++ )
      {
         if( i+next < 0)
            continue;
         if( i+next >= ZEILEN )
            continue;
         if( iSrc+next >= sizeof pDoc->m_data)
            continue;
         int iNext = i+next;
         if( next == 1 && pDoc->m_Format[iSrc].m_nRadioAs >= 1 )
            m_arZeilen[ iNext ].DisableControls();
         if( next == 2 && pDoc->m_Format[iSrc].m_nRadioAs == 2  )
         {
            m_arZeilen[ iNext ].DisableControls();
         }
         if( next == 3 && pDoc->m_Format[iSrc].m_nRadioAs == 2  )
         {
            m_arZeilen[ iNext ].DisableControls();
         }

      }
   }
}


void CAvrHexEepromView::UpdateControls()
{
   CAvrHexEepromDoc* pDoc = GetDocument();

   for( int i=0 ; i< ZEILEN &&  i + m_dwStartZeile < sizeof pDoc->m_data + ZEILEN ; i++ )
   {
      m_arZeilen[i].SetDataPointer( &pDoc->m_data[i + m_dwStartZeile] );
      m_arZeilen[i].SetDataAddress( i + m_dwStartZeile );
      m_arZeilen[i].SetDataFormat ( &pDoc->m_Format[i + m_dwStartZeile]  );
      m_arZeilen[i].UpdateControls();
   }
}


void CAvrHexEepromView::UpdateControlAddAndPointer()
{
   CAvrHexEepromDoc* pDoc = GetDocument();
   UpdateControls();
   EnableDisableControls();

   CScrollBar* pBar = (CScrollBar*)GetDlgItem(IDC_SCROLLBAR_H);
   if( pBar )
   {
      ASSERT( pBar->GetSafeHwnd() == GetDlgItem(IDC_SCROLLBAR_H)->GetSafeHwnd());
      pBar->SetScrollRange(0, sizeof pDoc->m_data / ZEILEN );
      pBar->SetScrollPos(m_dwStartZeile / ZEILEN);
   }

}
// OLE-Serveruntersttzung

// Der folgende Befehlshandler stellt die Standardtastatur als
//  Benutzerschnittstelle zum Abbruch der direkten Bearbeitungssitzung zur Verfgung. Hier
//  verursacht der Container (nicht der Server) die Deaktivierung.
// void CAvrHexEepromView::OnCancelEditSrvr()
// {
// 	GetDocument()->OnDeactivateUI(FALSE);
// }

void CAvrHexEepromView::OnUpdateDataTrueFalse( UINT nID )
{
   CAvrHexEepromDoc* pDoc = GetDocument();
   UpdateData();
   pDoc->UpdateAllViews(NULL,-1,NULL);
}

// CAvrHexEepromView-Diagnose

#ifdef _DEBUG
void CAvrHexEepromView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAvrHexEepromView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CAvrHexEepromDoc* CAvrHexEepromView::GetDocument() const // Nichtdebugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAvrHexEepromDoc)));
	return (CAvrHexEepromDoc*)m_pDocument;
}
#endif //_DEBUG


// CAvrHexEepromView-Meldungshandler
void CAvrHexEepromView::UpdateIntelHex()
{
   CAvrHexEepromDoc* pDoc = GetDocument();
   pDoc->BytesToString();
   SetDlgItemText( IDC_EDIT_BYTES_RAW, pDoc->m_strIntelHex);
}
void CAvrHexEepromView::OnBnClickedRange(UINT nID)
{
   nID -= ID_START_CONTROL;
   int zeile = nID % CONTROL_DELTA;
   int spalte= nID / CONTROL_DELTA;
   m_arZeilen[ zeile ].OnBnClicked( spalte );
   EnableDisableControls();
}
void CAvrHexEepromView::OnEnChangeRange(UINT nID)
{
   
   if( m_bLockRekursive )
      return;
   m_bLockRekursive = TRUE;
   nID -= ID_START_CONTROL;
   int zeile = nID % CONTROL_DELTA;
   int spalte= nID / CONTROL_DELTA;
   m_arZeilen[ zeile ].OnEnChange( spalte );
   for( int i=zeile+1 ; i<ZEILEN ; i++ )
      m_arZeilen[i].UpdateControls();
   m_bLockRekursive = FALSE;
   UpdateIntelHex();

}
void CAvrHexEepromView::OnEnChangeSize(UINT nID)
{
   static BOOL bLockRekursive = FALSE;
   if( bLockRekursive )
      return;
   bLockRekursive = TRUE;
   CAvrHexEepromDoc* pDoc = GetDocument();
   CString str;
   if( nID = IDC_EDIT_SIZE_DEZ )
   {
      long nTmp = GetDlgItemInt(IDC_EDIT_SIZE_DEZ);
      if( nTmp )
      {
         if( pDoc->m_nBytes != nTmp )
         {
            if( nTmp > sizeof pDoc->m_data )
               nTmp = sizeof pDoc->m_data;
            pDoc->m_nBytes = nTmp;
            pDoc->UpdateAllViews(NULL, IDC_EDIT_SIZE_DEZ, NULL);
         }
      }
   }
   if( nID = IDC_EDIT_SIZE_HEX )
   {
      GetDlgItemText(IDC_EDIT_SIZE_HEX, str );
      if( str.GetLength() )
      {
         long nTmp = 0;
         nTmp   =  AsciiHexToLong(str.GetString());
         if( pDoc->m_nBytes != nTmp )
         {
            if( nTmp > sizeof pDoc->m_data )
               nTmp = sizeof pDoc->m_data;
            pDoc->m_nBytes = nTmp;
            pDoc->UpdateAllViews(NULL, IDC_EDIT_SIZE_HEX, NULL);
         }
      }
   }
   bLockRekursive = FALSE;

}
void CAvrHexEepromView::OnEnChangeStartAdd(UINT nID)
{
   static BOOL bLockRekursive = FALSE;
   if( bLockRekursive )
      return;
   bLockRekursive = TRUE;
   CAvrHexEepromDoc* pDoc = GetDocument();
   CString str;
   if( nID = IDC_EDIT_SIZE_DEZ2 )
   {
      long nTmp = GetDlgItemInt(IDC_EDIT_SIZE_DEZ2);
      if( nTmp )
      {
         if( pDoc->m_nStartByteAdd != nTmp )
         {
            pDoc->m_nStartByteAdd = GetDlgItemInt(IDC_EDIT_SIZE_DEZ2);
            pDoc->UpdateAllViews(NULL, IDC_EDIT_SIZE_DEZ2, NULL);
         }
      }
   }
   if( nID = IDC_EDIT_SIZE_HEX2 )
   {
      GetDlgItemText(IDC_EDIT_SIZE_HEX2, str );
      if( str.GetLength() )
      {
         long nTmp = 0;
         nTmp   =  AsciiHexToLong(str.GetString());
         if( pDoc->m_nStartByteAdd != nTmp )
         {
            pDoc->m_nStartByteAdd = nTmp;
            pDoc->UpdateAllViews(NULL, IDC_EDIT_SIZE_HEX2, NULL);
         }
      }
   }
   bLockRekursive = FALSE;

}
void CAvrHexEepromView::OnUpdate(CView* /*pSender*/, LPARAM lHint, CObject* /*pHint*/)
{
   CAvrHexEepromDoc* pDoc = GetDocument();

   if( lHint == CAvrHexEepromDoc::HintNewFormat )
   {
      UpdateControls();
      return;
   }

   CString str;
   CString strAll;

   long nBytesPerCol = (1<<pDoc->m_nBytesColBit);
   int i=0;
   int addr = 0;
//    for( int y=0 ; y<64 ; y++ )
//    {
//       str.Format( _T("%04X "), y*nBytesPerCol );
//       strAll += str;
//       for( int s=0 ; s<nBytesPerCol ; s++ )
//       {
//          if(0 == s%4) 
//             strAll += _T(" ");
//          str.Format( _T("%02X"), pDoc->m_data[i++] );
//          strAll += str;
//       }
//       strAll += _T("\r\n");
//    }
   //SetDlgItemText( IDC_EDIT_BYTES_RAW, strAll );

   SetDlgItemText( IDC_EDIT_BYTES_RAW, pDoc->m_strIntelHex );
   
   if( lHint != IDC_EDIT_SIZE_DEZ) 
      SetDlgItemInt ( IDC_EDIT_SIZE_DEZ, pDoc->m_nBytes );
   str.Format( _T("%04X"), pDoc->m_nBytes );
   if( lHint != IDC_EDIT_SIZE_HEX) 
      SetDlgItemText( IDC_EDIT_SIZE_HEX, str );

   if( lHint != IDC_EDIT_SIZE_DEZ2) 
      SetDlgItemInt ( IDC_EDIT_SIZE_DEZ2, pDoc->m_nStartByteAdd );
   str.Format( _T("%04X"), pDoc->m_nStartByteAdd );
   if( lHint != IDC_EDIT_SIZE_HEX2) 
      SetDlgItemText( IDC_EDIT_SIZE_HEX2, str );

   UpdateData(FALSE);
   UpdateIntelHex();
}

void CAvrHexEepromView::OnSize(UINT nType, int cx, int cy)
{
   CFormView::OnSize(nType, cx, cy);
   if( GetDlgItem(IDC_SCROLLBAR_H))
   {
      CRect rect;
      GetDlgItem(IDC_SCROLLBAR_H)->GetWindowRect(rect);
      ScreenToClient(rect);
      if(cy-5 > rect.top)
      {
         rect.bottom = cy-5;
         GetDlgItem(IDC_SCROLLBAR_H)->MoveWindow(rect);
      }
   }
   // TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein.
}
void CAvrHexEepromView::IncStartZeile( int nPlusZeilen)
{
   CAvrHexEepromDoc* pDoc = GetDocument();

   m_dwStartZeile += nPlusZeilen;
   m_dwStartZeile = min( m_dwStartZeile, (sizeof pDoc->m_data)-1-ZEILEN );
   UpdateControlAddAndPointer();
}
void CAvrHexEepromView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
   CAvrHexEepromDoc* pDoc = GetDocument();
   //Scrollbar fr das Weiterbltern?
   if( pScrollBar->GetSafeHwnd() == GetDlgItem(IDC_SCROLLBAR_H)->GetSafeHwnd() )
   {
      switch (nSBCode)
      {
      case SB_BOTTOM       :    break;         //    SB_BOTTOM         Scroll to bottom. 
      case SB_ENDSCROLL    :    break;         //    SB_ENDSCROLL      End scroll. 
      case SB_LINEDOWN     :    if(m_dwStartZeile< (sizeof pDoc->m_data)) IncStartZeile(  ZEILEN);  break;         //    SB_LINEDOWN       Scroll one line down. 
      case SB_LINEUP       :    if(m_dwStartZeile> 1                    ) IncStartZeile( -ZEILEN);  break;         //    SB_LINEUP          Scroll one line up. 
      case SB_PAGEDOWN     :    if(m_dwStartZeile< (sizeof pDoc->m_data)) IncStartZeile(  ZEILEN);  break;         //    SB_PAGEDOWN       Scroll one page down. 
      case SB_PAGEUP       :    if(m_dwStartZeile> 1                    ) IncStartZeile( -ZEILEN);  break;         //    SB_PAGEUP         Scroll one page up. 
      case SB_THUMBPOSITION:    break;         //    SB_THUMBPOSITION   Scroll to the absolute position. The current position is provided in nPos. 
      case SB_THUMBTRACK   :    m_dwStartZeile = nPos*ZEILEN; IncStartZeile(0); ; break;         //    SB_THUMBTRACK      Drag scroll box to specified position. The current position is provided in nPos. 
      case SB_TOP          :    break;         //    SB_TOP             Scroll to top. 
      }
   }
   CFormView::OnVScroll(nSBCode, nPos, pScrollBar);
}
