//////////////////////////////////////////////////////////////////////////////
//
// LASE GmbH - Industrielle Lasertechnik
//
// $Workfile: HyperLink.h $ 
//
// $Date: 26.11.08 15:52 $
//
// $Revision: 1 $ 
//
// $Author: Norbert $ 
//
//////////////////////////////////////////////////////////////////////////////

#pragma once
#include "afxwin.h"

class CHyperLink :
   public CStatic
{
public:
   CHyperLink(void);
   ~CHyperLink(void);

   // Operationen
public:

   void SetURL(CString strURL);
   CString GetURL() const;

   void SetColours(COLORREF crLinkColour, COLORREF crVisitedColour, 
      COLORREF crHoverColour = -1);
   COLORREF GetLinkColour() const;
   COLORREF GetVisitedColour() const;
   COLORREF GetHoverColour() const;

   void SetVisited(BOOL bVisited = TRUE);
   BOOL GetVisited() const;

   void SetLinkCursor(HCURSOR hCursor);
   HCURSOR GetLinkCursor() const;

   void SetUnderline(BOOL bUnderline = TRUE);
   BOOL GetUnderline() const;

   void SetAutoSize(BOOL bAutoSize = TRUE);
   BOOL GetAutoSize() const;

   // berladungen
   // Vom Klassenassistenten generierte berladungen virtueller Funktionen
   //{{AFX_VIRTUAL(CHyperLink)
public:
   virtual BOOL PreTranslateMessage(MSG* pMsg);
protected:
   virtual void PreSubclassWindow();
   //}}AFX_VIRTUAL

   // Implementierung
protected:
   HINSTANCE GotoURL(LPCTSTR url, int showcmd);
   void ReportError(int nError);
   LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);
   void PositionWindow();
   void SetDefaultCursor();

   // Protected Attribute
protected:
   // Hyperlink Farben
   COLORREF m_crLinkColour, m_crVisitedColour;
   // Farbe, wenn Zeigehand darber
   COLORREF m_crHoverColour;
   // Ist der Zeiger ber dem Control?
   BOOL     m_bOverControl;
   // Ist die Seite bereits besucht worden? 
   BOOL     m_bVisited;
   // Ist der Hyperlink mit Unterstrich?
   BOOL     m_bUnderline;
   // Ist genug Platz im Fenster
   BOOL     m_bAdjustToFit;
   // URL fr den Hyperlink
   CString  m_strURL;
   // Die Schrift mit Unterstrich
   CFont    m_Font;
   // Der Cursor fr den Hyperlink
   HCURSOR  m_hLinkCursor;
   // Fr den Tooltip
   CToolTipCtrl m_ToolTip;

   // Generierte Nachrichtenzuordnungsfunktionen
protected:
   //{{AFX_MSG(CHyperLink)
   afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
   afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
   afx_msg void OnMouseMove(UINT nFlags, CPoint point);
   //}}AFX_MSG
   afx_msg void OnClicked();
   DECLARE_MESSAGE_MAP()
};
